{$M 2048,0,0}
{
  Usage: set up a game with MASTER. Hack the ship you want to test
  into ship slot #1 usng Plangineer or some other host hacking tool.
  Edit the parameters (e.g. to test a Gravitonic ship with warp 7,
  set WARP=7, DISTANCE=2*49, and use a gravitonic hull in Plangineer).
  Don't forget to put some fuel on the ship.

  Run it.

  Result will be in logfile.txt.


  --Stefan
}

USES DOS;

CONST GAMEDIR  = 'GAME\';               { game will be here. Must include slash }
      HOST     = 'host046.exe';         { name of host.exe }
      LOGFILE  = 'logfile.txt';         { output file }
      WARP     = 9;                     { warp factor to use }
      DISTANCE = 2*81;                  { expected distance }
      NUMSHIPS = 500;                   { this many ships in ship.hst }
      X0       = 500;                   { ships will be placed here }
      Y0       = 500;

TYPE TTransfer=RECORD           { Mineral transfer command on a ship }
	N,T,D,M:INTEGER;
	Colonists:INTEGER;
	Supplies:INTEGER;
	Id:INTEGER;
     END;

TYPE TShipXY = RECORD
	X,Y:INTEGER;                            { 0     Position }
	Owner:INTEGER;                          { 4     Owner }
						{       Only ships with Owner<>0 are displayed in the chart }
	Mass:INTEGER;                           { 6     Mass }
     END;

TYPE TUserShip=RECORD
	ShipId:INTEGER;                         { ID }
	PlayerId:INTEGER;                       { Owner }
	fc:ARRAY[1..3] OF CHAR;                 { Fcode }
	Speed:INTEGER;                          { Warp }
	WaypointDX,WaypointDY:INTEGER;          { Waypoint relative X,Y }
	X,Y:INTEGER;                            { Position }
	Engine:INTEGER;                         { Engine type }
	Hull:INTEGER;                           { Hull type }
	Beam:INTEGER;                           { Primary weapon }
	BeamCnt:INTEGER;
	FtrCnt:INTEGER;                         { Fighter Bays }
	TLauncher:INTEGER;                      { Torpedo Type }
	Torps:INTEGER;                          { Number of Torps/Fighters }
	TLaunCnt:INTEGER;                       { Number of Torpedo launchers }
	Mission:INTEGER;                        { Mission }
	PrimaryEnemy:INTEGER;
	TowID:INTEGER;                          { ID for TOW Mission }
	Damage:INTEGER;                         { Damage % }
	Crew:INTEGER;                           { active Crew }
	Colonists:INTEGER;                      { colonists }
	Name:ARRAY[1..20] OF CHAR;              { Name }
	Neutronium,Tritanium,Duranium,          { Cargo }
	 Molybdenum:INTEGER;
	Supplies:INTEGER;
	Unload:TTransfer;                       { Ship-Planet }
	Transfer:TTransfer;                     { Ship-Enemy ship }
	InterceptId:INTEGER;                    { ID for INTERCEPT Mission }
	Money:INTEGER;                          { Money (<=10000) }
     END;

VAR sr     : TUserShip;
    f      : FILE;
    fxy    : FILE;
    log    : TEXT;
    count  : LONGINT;
    shipnr : INTEGER;
    xysave : ARRAY[1..NUMSHIPS] OF RECORD x,y:INTEGER; END;
    maxdist : REAL;
    maxdx,maxdy:INTEGER;
    maxxdist : REAL;
    maxxdx,maxxdy:INTEGER;

PROCEDURE Runhost;
VAR i, j : INTEGER;
    s    : TUserShip;
    dist : REAL;
CONST first : BOOLEAN = TRUE;
BEGIN
  Close(f);
  Close(fxy);
  Writeln('Running host for ', shipnr, ' ships');
  SwapVectors;
  Exec(HOST, GAMEDIR);
  SwapVectors;
  IF DOSError<>0 THEN BEGIN
    Writeln('DOS Error ', DOSError);
    Readln;
    Exit;
  END;
  Assign(F, GAMEDIR + 'ship.hst');
  Reset(f, 1);
  Assign(log, LOGFILE);
  IF first THEN BEGIN
    Rewrite(log);
    Writeln(log, '  ORDER      MOVED     REMAIN     DISTANCE      NOTES');
    Writeln(log, ' dx   dy    dx   dy    dx   dy   order moved   done/err');
    Writeln(log, '---- ----  ---- ----  ---- ----  ----- -----  ----------');
  END ELSE Append(log);
  first := FALSE;
  FOR i:=1 TO shipnr DO BEGIN
    Seek(f, LONGINT(Pred(i))*107+2);
    Blockread(f, s, Sizeof(s));
    dist := Sqrt(Sqr(LONGINT(s.x - X0)) + Sqr(LONGINT(s.y - Y0)));
    Write(log, xysave[i].x:4, xysave[i].y:5,
               s.x - X0:6, s.y - Y0:5,
               s.WaypointDX:6, s.WaypointDY:5,
               Sqrt(Sqr(LONGINT(xysave[i].x))+Sqr(LONGINT(xysave[i].y))):7:1,
               dist:6:1);
    IF (s.WaypointDX = 0) AND (s.WaypointDY = 0) THEN Write(log, '  done');
    IF (X0 + xysave[i].x <> s.x + s.WaypointDX)
     OR (Y0 + xysave[i].y <> s.y + s.WaypointDY)
    THEN Write(log, '  err');
    IF dist > maxdist THEN BEGIN
      maxdist := dist;
      maxdx:=xysave[i].x;
      maxdy:=xysave[i].y;
    END;
    IF (s.WaypointDX=0) AND (s.WaypointDY=0) AND (dist > maxxdist) THEN BEGIN
      maxxdist := dist;
      maxxdx:=xysave[i].x;
      maxxdy:=xysave[i].y;
    END;
    Writeln(log);
  END;
  Close(f);
  Close(log);
END;

PROCEDURE Runit(dx, dy : INTEGER); FAR;
VAR xyr : TShipXY;
BEGIN
  IF shipnr = 0 THEN BEGIN
    Assign(f, GAMEDIR + 'ship.hst');
    Reset(f, 1);
    Seek(f, 2);
    Blockread(f, sr, Sizeof(sr));
    Assign(fxy, GAMEDIR + 'shipxy.hst');
    Reset(fxy, 1);
  END;
  Inc(shipnr);
  sr.ShipId := shipnr;
  sr.Speed := WARP;
  sr.WaypointDX := dx;
  sr.WaypointDY := dy;
  sr.X := x0;
  sr.Y := y0;
  Seek(f, 107*Pred(LONGINT(shipnr))+2);
  Blockwrite(f, sr, Sizeof(sr));

  xyr.x := x0;
  xyr.y := y0;
  xyr.mass := 100;
  xyr.owner := sr.PlayerId;
  Seek(fxy, 8*Pred(shipnr));
  Blockwrite(fxy, xyr, Sizeof(xyr));

  xysave[shipnr].x := dx;
  xysave[shipnr].y := dy;

  IF shipnr >= NUMSHIPS THEN BEGIN
    RunHost;
    shipnr := 0;
  END;
END;

PROCEDURE Countit(dx, dy : INTEGER); FAR;
BEGIN
  Inc(count);
END;

TYPE ProcType = PROCEDURE(dy,dy:INTEGER);
PROCEDURE Doit(p:ProcType);
VAR dx, dy : INTEGER;
    di     : REAL;
BEGIN
  FOR dx := -(DISTANCE+5) TO (distance+5) DO
   FOR dy := -(DISTANCE+5) TO (distance+5) DO BEGIN
     di := Sqrt(LONGINT(dx)*dx+LONGINT(dy)*dy);
     IF (di >= DISTANCE-2) AND (di <= DISTANCE+5) THEN p(dx,dy);
   END;
END;

BEGIN
  count := 0;
  shipnr := 0;
  maxdist := 0;
  Doit(Countit);
  Writeln('I need to move ', count, ' ships, i.e. ',
          (count+NUMSHIPS-1) DIV NUMSHIPS, ' host runs.');
  Writeln('RET to start, CTRL-C to abort.');
  Readln;
  Doit(Runit);
  IF shipnr<>0 THEN Runhost;
  Assign(log, LOGFILE);
  Append(log);
  Writeln(log);
  Writeln(log, 'Did ', count, ' sims');
  Writeln(log, 'Maximum distance moved this turn: ', maxdist : 0 : 1,
               ' for movement ', maxdx, ',', maxdy);
  Writeln(log, 'Maximum exact distance: ', maxxdist : 0 : 1,
               ' for movement ', maxxdx, ',', maxxdy);
  Close(log);
END.
